<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class UploadedFile
{
    private $formFieldName;
    public $fileName;
    public $fileExtension;
    private $filters = array();
    
    function __construct($formFieldName)
    {
        $this->formFieldName = $formFieldName;
    }
    
    function addFilter($type, $value)
    {
        $this->filters[$type] = $value;
    }
    
    function check()
    {
        $formFieldName = $this->formFieldName;
        
        if(empty($_FILES[$formFieldName]))return false;
        
        if($_FILES[$formFieldName]['size'] == 0 || $_FILES[$formFieldName]['error'] != 0)return false;

        if(!is_uploaded_file($_FILES[$formFieldName]['tmp_name']))return false;
        
        $this->fileExtension = (preg_match("#\.([^\.]*)$#", $_FILES[$formFieldName]['name'], $m)) ? strtolower($m[1]) : "";
        
        if(!empty($this->filters['extension']) && !in_array($this->fileExtension, $this->filters['extension']))return false;
    
        return true;
    }
    
    function getTempName()
    {
        return $_FILES[$this->formFieldName]['tmp_name'];
    }
    
    function save($pathToSave)
    {
        if(!$this->check())return false;
        
        $formFieldName = $this->formFieldName;

        if(!$this->fileName)
        {
            do
            {
                // select new random name
                $imgSrc = rand(100000000000000000, 9999999999999999999). "." . $this->fileExtension;
            }while(file_exists($pathToSave . $imgSrc)); // while this name is already busy
            
            $this->fileName = $imgSrc; 
        }

        if(move_uploaded_file($_FILES[$formFieldName]['tmp_name'], $pathToSave . $this->fileName))
        {
            return $this->fileName;
        }
    }
}
        
?>